# - Find lzma
# Find the native lzma includes and library
#
#  LZMA_INCLUDE_DIR - where to find lzo/lzo1x.h, etc.
#  LZMA_LIBRARIES   - List of libraries when using lzo.
#  LZMA_FOUND       - True if lzo found.


IF(LZMA_INCLUDE_DIR)
  SET(LZMA_FIND_QUIETLY TRUE)
ENDIF(LZMA_INCLUDE_DIR)

FIND_PATH(LZMA_INCLUDE_DIR lzma.h)

SET(LZMA_NAMES lzma)
FIND_LIBRARY(LZMA_LIBRARY NAMES ${LZMA_NAMES})

INCLUDE(FindPackageHandleStandardArgs)
FIND_PACKAGE_HANDLE_STANDARD_ARGS(LZMA DEFAULT_MSG LZMA_LIBRARY LZMA_INCLUDE_DIR)

IF(LZMA_FOUND)
  SET(LZMA_LIBRARIES ${LZMA_LIBRARY})
ELSE(LZMA_FOUND)
  SET(LZMA_LIBRARIES)
ENDIF(LZMA_FOUND)

MARK_AS_ADVANCED(LZMA_LIBRARY LZMA_INCLUDE_DIR)
