# - Find lzo
# Find the native lzo includes and library
#
#  LZO_INCLUDE_DIR - where to find lzo/lzo1x.h, etc.
#  LZO_LIBRARIES   - List of libraries when using lzo.
#  LZO_FOUND       - True if lzo found.


IF(LZO_INCLUDE_DIR)
  SET(LZO_FIND_QUIETLY TRUE)
ENDIF(LZO_INCLUDE_DIR)

FIND_PATH(LZO_INCLUDE_DIR lzo/lzo1x.h)

SET(LZO_NAMES lzo2)
FIND_LIBRARY(LZO_LIBRARY NAMES ${LZO_NAMES})

INCLUDE(FindPackageHandleStandardArgs)
FIND_PACKAGE_HANDLE_STANDARD_ARGS(LZO DEFAULT_MSG LZO_LIBRARY LZO_INCLUDE_DIR)

IF(LZO_FOUND)
  SET(LZO_LIBRARIES ${LZO_LIBRARY})
ELSE(LZO_FOUND)
  SET(LZO_LIBRARIES)
ENDIF(LZO_FOUND)

MARK_AS_ADVANCED(LZO_LIBRARY LZO_INCLUDE_DIR)
