# - Find pcre
# Find the native pcre includes and library
#
#  PCRE_INCLUDE_DIR - where to find zlib.h, etc.
#  PCRE_LIBRARIES   - List of libraries when using zlib.
#  PCRE_FOUND       - True if zlib found.


IF(PCRE_INCLUDE_DIR)
  SET(PCRE_FIND_QUIETLY TRUE)
ENDIF(PCRE_INCLUDE_DIR)

FIND_PATH(PCRE_INCLUDE_DIR pcre.h)

SET(PCRE_NAMES pcre)
FIND_LIBRARY(PCRE_LIBRARY NAMES ${PCRE_NAMES})

INCLUDE(FindPackageHandleStandardArgs)
FIND_PACKAGE_HANDLE_STANDARD_ARGS(PCRE DEFAULT_MSG PCRE_LIBRARY PCRE_INCLUDE_DIR)

IF(PCRE_FOUND)
  SET(PCRE_LIBRARIES ${PCRE_LIBRARY})
ELSE(PCRE_FOUND)
  SET(PCRE_LIBRARIES)
ENDIF(PCRE_FOUND)

MARK_AS_ADVANCED(PCRE_LIBRARY PCRE_INCLUDE_DIR)
