#ifndef CLASSLIB_NONSTDINT_H
# define CLASSLIB_NONSTDINT_H 1
# if ! _MSC_VER
#  include <stdint.h>

# else // _MSC_VER
#  include <limits.h>
//#  include <wchar.h> {WCHAR,WINT}_{MIN,MAX}?

   typedef __int8		int8_t;
   typedef __int16		int16_t;
   typedef __int32		int32_t;
   typedef __int64		int64_t;
   typedef unsigned __int8	uint8_t;
   typedef unsigned __int16	uint16_t;
   typedef unsigned __int32	uint32_t;
   typedef unsigned __int64	uint64_t;

   typedef int8_t		int_least8_t;
   typedef int16_t		int_least16_t;
   typedef int32_t		int_least32_t;
   typedef int64_t		int_least64_t;
   typedef uint8_t		uint_least8_t;
   typedef uint16_t		uint_least16_t;
   typedef uint32_t		uint_least32_t;
   typedef uint64_t		uint_least64_t;

   typedef int8_t		int_fast8_t;
   typedef int16_t		int_fast16_t;
   typedef int32_t		int_fast32_t;
   typedef int64_t		int_fast64_t;
   typedef uint8_t		uint_fast8_t;
   typedef uint16_t		uint_fast16_t;
   typedef uint32_t		uint_fast32_t;
   typedef uint64_t		uint_fast64_t;

   typedef int64_t		intmax_t;
   typedef uint64_t		uintmax_t;

#  ifdef _WIN64
   typedef int64_t		intptr_t;
   typedef uint64_t		uintptr_t;
#  else
   typedef int32_t		intptr_t;
   typedef uint32_t		uintptr_t;
#  endif

#  if ! defined __cplusplus || defined __STDC_LIMIT_MACROS
#   define INT8_MIN		((int8_t)_I8_MIN)
#   define INT8_MAX		_I8_MAX
#   define INT16_MIN		((int16_t)_I16_MIN)
#   define INT16_MAX		_I16_MAX
#   define INT32_MIN		((int32_t)_I32_MIN)
#   define INT32_MAX		_I32_MAX
#   define INT64_MIN		((int64_t)_I64_MIN)
#   define INT64_MAX		_I64_MAX
#   define UINT8_MAX		_UI8_MAX
#   define UINT16_MAX		_UI16_MAX
#   define UINT32_MAX		_UI32_MAX
#   define UINT64_MAX		_UI64_MAX

#   define INT_LEAST8_MIN	INT8_MIN
#   define INT_LEAST8_MAX	INT8_MAX
#   define INT_LEAST16_MIN	INT16_MIN
#   define INT_LEAST16_MAX	INT16_MAX
#   define INT_LEAST32_MIN	INT32_MIN
#   define INT_LEAST32_MAX	INT32_MAX
#   define INT_LEAST64_MIN	INT64_MIN
#   define INT_LEAST64_MAX	INT64_MAX
#   define UINT_LEAST8_MAX	UINT8_MAX
#   define UINT_LEAST16_MAX	UINT16_MAX
#   define UINT_LEAST32_MAX	UINT32_MAX
#   define UINT_LEAST64_MAX	UINT64_MAX

#   define INT_FAST8_MIN	INT8_MIN
#   define INT_FAST8_MAX	INT8_MAX
#   define INT_FAST16_MIN	INT16_MIN
#   define INT_FAST16_MAX	INT16_MAX
#   define INT_FAST32_MIN	INT32_MIN
#   define INT_FAST32_MAX	INT32_MAX
#   define INT_FAST64_MIN	INT64_MIN
#   define INT_FAST64_MAX	INT64_MAX
#   define UINT_FAST8_MAX	UINT8_MAX
#   define UINT_FAST16_MAX	UINT16_MAX
#   define UINT_FAST32_MAX	UINT32_MAX
#   define UINT_FAST64_MAX	UINT64_MAX

#   define INTMAX_MIN		INT64_MIN
#   define INTMAX_MAX		INT64_MAX
#   define UINTMAX_MAX		UINT64_MAX

#   ifdef _WIN64
#    define INTPTR_MIN		INT64_MIN
#    define INTPTR_MAX		INT64_MAX
#    define UINTPTR_MAX		UINT64_MAX
#    define PTRDIFF_MIN		_I64_MIN
#    define PTRDIFF_MAX		_I64_MAX
#   else
#    define INTPTR_MIN		INT32_MIN
#    define INTPTR_MAX		INT32_MAX
#    define UINTPTR_MAX		UINT32_MAX
#    define PTRDIFF_MIN		_I32_MIN
#    define PTRDIFF_MAX		_I32_MAX
#   endif

#   define SIG_ATOMIC_MIN	INT_MIN
#   define SIG_ATOMIC_MAX	INT_MAX

#  endif // ! defined __cplusplus || defined __STDC_LIMIT_MACROS

#  if ! defined __cplusplus || defined __STDC_CONSTANT_MACROS
#   define INT8_C(val)		val##i8
#   define INT16_C(val)		val##i16
#   define INT32_C(val)		val##i32
#   define INT64_C(val)		val##i64

#   define UINT8_C(val)		val##ui8
#   define UINT16_C(val)	val##ui16
#   define UINT32_C(val)	val##ui32
#   define UINT64_C(val)	val##ui64
#  endif // ! defined __cplusplus || defined __STDC_CONSTANT_MACROS
# endif // _MSC_VER
#endif // CLASSLIB_NONSTDINT_H
